﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

using System.Drawing.Imaging;
using System.Runtime.InteropServices;

using libpxcclr;
namespace Starter
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            PXCMSession session = PXCMSession.CreateInstance();
            PXCMSession.ImplVersion version = session.QueryVersion();
            textBox1.Text = version.major.ToString() + "." + version.minor.ToString();

            PXCMSenseManager sm = session.CreateSenseManager();
            sm.EnableStream(PXCMCapture.StreamType.STREAM_TYPE_COLOR, 0, 0);
            sm.EnableStream(PXCMCapture.StreamType.STREAM_TYPE_DEPTH, 0, 0);

            sm.Init();
            pxcmStatus status = sm.AcquireFrame(true);

            PXCMCapture.Sample sample = sm.QuerySample();
            PXCMImage image = sample.color;
            PXCMImage dimage = sample.depth;

            PXCMImage.ImageData data;
            image.AcquireAccess(PXCMImage.Access.ACCESS_READ, PXCMImage.PixelFormat.PIXEL_FORMAT_RGB32, out data);
            Bitmap bm = data.ToBitmap(0, image.info.width, image.info.height);



            PXCMImage.ImageData data2;
            dimage.AcquireAccess(PXCMImage.Access.ACCESS_READ, PXCMImage.PixelFormat.PIXEL_FORMAT_DEPTH_RAW, out data2);
            Int16[] buffer = data2.ToShortArray(0, dimage.info.width * dimage.info.height);

            Bitmap bm2 = new Bitmap(dimage.info.width, dimage.info.height, PixelFormat.Format16bppRgb555);
            BitmapData bmapdata = bm2.LockBits(new Rectangle(0, 0, dimage.info.width, dimage.info.height), ImageLockMode.WriteOnly, bm2.PixelFormat);
            IntPtr ptr = bmapdata.Scan0;
            Marshal.Copy(buffer, 0,
             ptr,
             dimage.info.width * dimage.info.height);
            bm2.UnlockBits(bmapdata);
            pictureBox1.Image = bm;
            pictureBox2.Image = bm2;


            sm.ReleaseFrame();
            sm.Close();
            session.Dispose();


        }
    }
}
